#
# Solution to CS 224 Closed Lab 03
#

from os import listdir
from random import random, randint

path = 'datafiles'

def rand_even(f):
    fn = open ('datafiles/' + f + '/' + f + '.rand', 'r')
    val = int(fn.readline().rstrip())
    fn.close()
    return val % 2 == 0


def main():
    print()

    # list comprehension that creates a list of the run.x directories within the 
    # datafiles directory that contain a file named run.x.rand
    files0 = [f for f in listdir(path) if f + '.rand' in listdir(path + '/' + f)]
    print('Part 1:\n{}'.format(files0))
    print()

    # list comprehension that creates a list of the run.x directories within the
    # datafiles directory for which x is even
    files1 = [f for f in listdir(path) if int(f.split('.')[1]) % 2 == 0]
    print('Part 2:\n{}'.format(files1))
    print()

    # list comprehension that creates a list of pairs (run.x, run.y) of directories 
    # from datafiles such that (x + y) mod 100 = 0
    files2 = [(f1, f2) for f1 in listdir(path) for f2 in listdir(path) if (int(f1.split('.')[1]) + int(f2.split('.')[1])) % 100 == 0]
    print('Part 3:\n{}'.format(files2))
    print()

    # list comprehension that creates a list of the run.x directories in which the run.x.rand file
    # contains an even number
    files3 = [f for f in listdir(path) if f + '.rand' in listdir(path + '/' + f) and rand_even(f)]
    print('Part 4a:\n{}'.format(files3))
    print()

    # list comprehension that creates a list of the run.x directories in which the run.x.rand file
    # contains an even number
    # A second way
    files3 = [f for f in listdir(path) if f + '.rand' in listdir(path + '/' + f) and 
             int(open(path + '/' + f + '/' + f + '.rand', 'r').read()) % 2 == 0]
    print('Part 4b:\n{}'.format(files3))
    print()

    
if __name__ == '__main__':
    main()
    